`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/04/2020 01:36:03 PM
// Design Name: 
// Module Name: stopwatch
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Date(
    clk,
    increase,
    reset,
    day_0,
    day_1,
    month_0,
    month_1,
    year_0,
    year_1,
    year_2,
    year_3
    );
    input clk, increase, reset;
    output [3:0]day_0, day_1, month_0, month_1, year_0, year_1, year_2, year_3;
    wire   carry1_2, carry2_3, carry3_4, carry4_5, carry5_6, carry6_7;
    reg rst_day, rst_month;
    
    wire [11:0]year;
    reg [3:0]LeapDay;   // for Feburary
    assign year = year_3*1000 + year_2*100 + year_1*10 + year_0;
    
    always @*
        if((year % 4 == 0 && year % 100 != 0) || year % 400 == 0)
            LeapDay = 4'd9;
        else
            LeapDay = 4'd8;
    
    always @*
      if(month_1 == 4'd1 && month_0 == 4'd2 && day_1 == 4'd3 && day_0 == 4'd1)
          begin
                rst_month = 1;
          end
      else
          begin
                rst_month = 0;  
          end    
    always @*
        if(month_1 == 4'd0 && month_0 == 4'd1 && day_1 == 4'd3 && day_0 == 4'd1)
                rst_day = 1;
        else if(month_1 == 4'd0 && month_0 == 4'd2 && day_1 == 4'd2 && day_0 == LeapDay) 
            begin
                rst_day = 1;
            end
        else if(month_1 == 4'd0 && month_0 == 4'd3 && day_1 == 4'd3 && day_0 == 4'd1) 
           begin
                rst_day = 1;
           end
        else if(month_1 == 4'd0 && month_0 == 4'd4 && day_1 == 4'd3 && day_0 == 4'd0) 
             begin
                 rst_day = 1;
             end
        else if(month_1 == 4'd0 && month_0 == 4'd5 && day_1 == 4'd3 && day_0 == 4'd1) 
             begin
                 rst_day = 1;
             end
        else if(month_1 == 4'd0 && month_0 == 4'd6 && day_1 == 4'd3 && day_0 == 4'd0) 
           begin
               rst_day = 1;
           end
        else if(month_1 == 4'd0 && month_0 == 4'd7 && day_1 == 4'd3 && day_0 == 4'd1) 
             begin
                 rst_day = 1;
             end
        else if(month_1 == 4'd0 && month_0 == 4'd8 && day_1 == 4'd3 && day_0 == 4'd1) 
            begin
                rst_day = 1;
            end
        else if(month_1 == 4'd0 && month_0 == 4'd9 && day_1 == 4'd3 && day_0 == 4'd0) 
             begin
                rst_day = 1;
             end
        else if(month_1 == 4'd1 && month_0 == 4'd0 && day_1 == 4'd3 && day_0 == 4'd1) 
             begin
                rst_day = 1;
             end
        else if(month_1 == 4'd1 && month_0 == 4'd1 && day_1 == 4'd3 && day_0 == 4'd0) 
             begin
                rst_day = 1;
             end
        else if(month_1 == 4'd1 && month_0 == 4'd2 && day_1 == 4'd3 && day_0 == 4'd1)
              begin
                rst_day = 1;
              end
        else 
            begin 
                rst_day = 0;
             end
    Day U_day(
    .day_0(day_0),
    .day_1(day_1),
    .increase(increase),
    .clk(clk),
    .rst_day(rst_day),
    .rst(reset),
    .carry(carry1_2)
    );
     Digit U_month_digit0(
    .value(month_0), // counter output
    .increase(carry1_2), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .carry(carry2_3),
    .limit(4'd9),
    .rst_day(1'b0),
    .set_value(4'd1),
    .rst_month(rst_month)
    );
     Digit U_month_digit1(
    .value(month_1), // counter output
    .increase(carry2_3), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .carry(carry3_4),
    .limit(4'd1),
    .rst_day(1'b0),
    .set_value(4'd0),
    .rst_month(rst_month)
    );
    Digit U_year_digit0(
    .value(year_0), // counter output
    .increase(carry3_4), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .carry(carry4_5),
    .limit(4'd9),
    .set_value(4'd0)
    );
     Digit U_year_digit1(
    .value(year_1), // counter output
    .increase(carry4_5), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .carry(carry5_6),
    .limit(4'd9),
    .set_value(4'd0)
    );
     Digit U_year_digit2(
    .value(year_2), // counter output
    .increase(carry5_6), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .carry(carry6_7),
    .limit(4'd9),
    .set_value(4'd0)
    );
     Digit U_year_digit3(
    .value(year_3), // counter output
    .increase(carry6_7), // borrow indicator
    .clk(clk), // global clock
    .rst(reset), // active low reset
    .limit(4'd9),
    .set_value(4'd2)
    );
    
endmodule
