`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/09/2020 05:42:38 PM
// Design Name: 
// Module Name: Lab7_1
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab7_1(
    f_crystal,
    rst,
    show_sec,
    ssd_ctl,
    D_ssd,
    mode,
    count_frq,
    ssd_clk,
    carry_to_day,
    stop
    );
    input stop;
    input f_crystal, rst, show_sec, mode, count_frq;
    input [1:0]ssd_clk;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    output carry_to_day;
    wire [1:0]ssd_clk;
    wire [3:0]sec_0, sec_1, min_0, min_1, hr_0, hr_1;
    wire [3:0]hr_0_ver2, hr_1_ver2;
    reg [3:0]disp_0, disp_1, disp_2, disp_3;
    wire [3:0]display;
    wire point;
    reg increase;
    
    Time U1(
    .clk(count_frq),
    .increase(increase),
    .reset(rst),
    .sec_0(sec_0),
    .sec_1(sec_1),
    .min_0(min_0),
    .min_1(min_1),
    .hr_0(hr_0),
    .hr_1(hr_1),
    .mode(mode),
    .carry_to_day(carry_to_day)
    );
    hr_disp(
    .hr_0_ori(hr_0),
    .hr_1_ori(hr_1),
    .hr_0_mod(hr_0_ver2),
    .hr_1_mod(hr_1_ver2),
    .mode(mode)
    );
    
    always @*
        if(stop && hr_1 == 4'd2 && hr_0 == 4'd3 && min_1 == 4'd5 && min_0 == 4'd9 && sec_1 == 4'd5 && sec_0 == 4'd9)
            begin
                increase = 1'b0;
            end
        else
            begin
                increase = 1'b1;
            end
    
    always @*
        if(show_sec)
            begin
                disp_0 = sec_0;
                disp_1 = sec_1;
                disp_2 = 4'd0;
                disp_3 = 4'd0;
            end
        else
            begin
                disp_0 = min_0;
                disp_1 = min_1;
                disp_2 = hr_0_ver2;
                disp_3 = hr_1_ver2;
            end
    scan_ctl7_1 U2(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in3(disp_3),
      .ssd_in(display),
      .ssd_ctl_clk(ssd_clk),
      .point(point)  
    );
    Display_7_segment7_1 U3(.D_ssd(D_ssd), .i(display), .point(point));

endmodule
